config/urls.py
from django.conf import settings

from django.urls import re_path, include

from django.contrib import admin
from django.contrib.auth.views import LogoutView
from django.views.generic import TemplateView

# Import feeds
import core.views
from events.feeds import EventFeed, feedview
import events.reports
import events.views
from ligoauth.views import (
    manage_password, ShibLoginView, ShibPostLoginView
)
import search.views

# Django admin auto-discover
admin.autodiscover()

feeds = {
    'latest' : EventFeed
}


urlpatterns = [
    re_path(r'^$', events.views.index, name="home"),
    re_path(r'^navbar_only$', TemplateView.as_view(
        template_name='navbar_only.html'), name="navbar-only"),
    re_path(r'^SPInfo', TemplateView.as_view(template_name='gracedb/spinfo.html'),
         name="spinfo"),
    re_path(r'^SPPrivacy', TemplateView.as_view(
        template_name='gracedb/spprivacy.html'), name="spprivacy"),
    re_path(r'^DiscoveryService', TemplateView.as_view(
        template_name='discovery.html'), name="discovery"),
    re_path(r'^events/', include('events.urls')),
    re_path(r'^superevents/', include('superevents.urls')),
    re_path(r'^alerts/', include('alerts.urls')),
    re_path(r'^feeds/(?P<url>.*)/$', EventFeed()),
    re_path(r'^feeds/$', feedview, name="feeds"),

    re_path(r'^other/$', TemplateView.as_view(template_name='other.html'),
        name='other'),
    re_path(r'^performance/$', events.views.performance, name="performance"),
    re_path(r'^reports/$', events.reports.histo, name="reports"),
    re_path(r'^latest/$', search.views.latest, name="latest"),
    #(r'^reports/(?P<path>.+)$', 'django.views.static.serve',
    #        {'document_root': settings.LATENCY_REPORT_DEST_DIR}),
    re_path(r'^search/$', search.views.search, name="mainsearch"),

    # Authentication
    re_path(r'^login/$', ShibLoginView.as_view(), name='login'),
    re_path(r'^post-login/$', ShibPostLoginView.as_view(), name='post-login'),
    re_path(r'^logout/$', LogoutView.as_view(), name='logout'),

    # Password management
    re_path('^manage-password/$', manage_password, name='manage-password'),

    # API URLs
    re_path(r'^api/', include('api.urls')),
    # Legacy API URLs - must be maintained!
    re_path(r'^apibasic/', include('api.urls', namespace='legacy_apibasic')),
    re_path(r'^apiweb/', include('api.urls', namespace='legacy_apiweb')),

    # Heartbeat URL
    re_path(r'^heartbeat/$', core.views.heartbeat, name='heartbeat'),

    # Uncomment the admin/doc line below and add 'django.contrib.admindocs'
    # to INSTALLED_APPS to enable admin documentation:
    # (r'^admin/doc/', include('django.contrib.admindocs.urls')),
    re_path(r'^admin/', admin.site.urls),

    # Sessions
    re_path(r'^', include('user_sessions.urls', 'user_sessions')),

]

# We don't require settings.DEBUG for django-silk since running unit tests
# by default setings settings.DEBUG to False, unless you use the
# --debug-mode flag
if ('silk' in settings.INSTALLED_APPS):
    # Add django-silk
    urlpatterns = [
        re_path(r'^silk/', include('silk.urls', namespace='silk'))
    ] + urlpatterns

# Add django-debug-toolbar
if settings.DEBUG and 'debug_toolbar' in settings.INSTALLED_APPS:
    import debug_toolbar
    urlpatterns = [
        re_path(r'^__debug__/', include(debug_toolbar.urls)),
    ] + urlpatterns

gracedb/alerts/urls.py
from django.urls import re_path

from . import views

app_name = 'alerts'


urlpatterns = [
    # Base /options/ URL
    re_path(r'^$', views.index, name="index"),

    # Contacts
    re_path(r'^contact/create/', views.CreateContactView.as_view(),
        name='create-contact'),
    re_path(r'^contact/(?P<pk>\d+)/edit/$', views.EditContactView.as_view(),
        name="edit-contact"),
    re_path(r'^contact/(?P<pk>\d+)/delete/$', views.DeleteContactView.as_view(),
        name="delete-contact"),
    re_path(r'^contact/(?P<pk>\d+)/test/$', views.TestContactView.as_view(),
        name="test-contact"),
    re_path(r'^contact/(?P<pk>\d+)/request-code/$',
        views.RequestVerificationCodeView.as_view(),
        name="request-verification-code"),
    re_path(r'^contact/(?P<pk>\d+)/verify/$', views.VerifyContactView.as_view(),
        name="verify-contact"),

    # Notifications
    re_path(r'^notification/create/$', views.CreateNotificationView.as_view(),
        name="create-notification"),
    re_path(r'^notification/(?P<pk>\d+)/edit/$',
        views.EditNotificationView.as_view(), name="edit-notification"),
    re_path(r'^notification/(?P<pk>\d+)/delete/$',
        views.DeleteNotificationView.as_view(), name="delete-notification"),
]

gracedb/api/urls.py
from django.urls import re_path, include

from .v1 import urls as v1_urls
from .v2 import urls as v2_urls

app_name = 'api'

urlpatterns = [
    re_path(r'^', include((v1_urls, 'default'))),
    re_path(r'^v1/', include((v1_urls, 'v1'))),
    re_path(r'^v2/', include((v2_urls, 'v2'))),
]

gracedb/core/urls.py
# URL utilities

from django.contrib.sites.models import Site


def build_absolute_uri(relative_uri, request=None):
    if request is not None:
        return request.build_absolute_uri(relative_uri)
    else:
        # Assume HTTPS
        domain = Site.objects.get_current().domain
        return 'https://' + domain + relative_uri

# A helper function to return superevent urls from /api/-->/apiweb/
# Note that event files are never exposed to the public and so aren't 
# subject to the same private api vs public apiweb caching schemes
def build_apiweb_uri(relative_uri, request=None):
    absolute_uri = build_absolute_uri(relative_uri, request=request)

    # Return the apiweb url for superevents:
    if '/superevents/' in absolute_uri:
        absolute_uri = absolute_uri.replace('/api/', '/apiweb/')

    return absolute_uri

gracedb/superevents/urls.py
from django.conf.urls import url, include
from django.urls import path
from .models import Superevent
from . import views

app_name = 'superevents'


# URLs which are nested below a superevent detail
# These are included under a superevent's ID URL prefix (see below)
suburlpatterns = [

    # Superevent detail view
    url(r'^view/$', views.SupereventDetailView.as_view(), name="view"),

    # File list (file detail/download is handled through the API)
    url(r'^files/$', views.SupereventFileList.as_view(), name="file-list"),
]

# Legacy URL patterns - don't really need them, but we use them for the
# convenience of users who may be accustomed to the legacy event URL patterns

# public page url patterns. This needs to go first so django matches 
# the 'public' string before parsing it interprets it as a superevent_id.
# Note to future generations: don't name a GW 'public' or the link breaks.

public_urlpatterns = [
    # The /superevents/public/ url route gets redirected to the 
    # latest observation run.
    path('public/', views.public_alerts_redirect,
        name="public-alerts-redirect"),

    # each run has its own page, but must be in the list of runs that's 
    # in settings/base.py. Otherwise, 404 (this gets defined in the view). 
    # the "obsrun" variable controls which events are shown.
     path('public/<slug:obsrun>/', views.SupereventPublic.as_view(),
         name="public-alerts"),

]
legacy_urlpatterns = public_urlpatterns + [
    # Legacy URLs for superevent detail view
    path('<str:superevent_id>/',
        views.SupereventDetailView.as_view(),
        name="legacyview1"),
    path('view/<str:superevent_id>/',
        views.SupereventDetailView.as_view(),
        name="legacyview2"),
]

# Full urlpatterns: legacy urls plus suburlpatterns nested under
# superevent_id
urlpatterns = legacy_urlpatterns + [
    path('<str:superevent_id>/',
        include(suburlpatterns)),

]

gracedb/alerts/views.py
import logging

from django.conf import settings
from django.contrib import messages
from django.core.mail import EmailMessage
from django.http import HttpResponseRedirect
from django.shortcuts import render
from django.urls import reverse, reverse_lazy
from django.utils import timezone
from django.utils.decorators import method_decorator
from django.views.generic.edit import DeleteView, UpdateView
from django.views.generic.detail import DetailView

from django_twilio.client import twilio_client

from core.views import MultipleFormView
from ligoauth.decorators import internal_user_required
from .forms import (
    PhoneContactForm, EmailContactForm, VerifyContactForm,
    EventNotificationForm, SupereventNotificationForm,
)
from . import egad
from .models import Contact, Notification
from .phone import get_twilio_from


# Set up logger
logger = logging.getLogger(__name__)


###############################################################################
# Generic views ###############################################################
###############################################################################
@internal_user_required
def index(request):
    context = {
        'notifications': request.user.notification_set.all(),
        'contacts': request.user.contact_set.all(),
    }

    return render(request, 'alerts/index.html', context=context)


###############################################################################
# Notification views ##########################################################
###############################################################################
@method_decorator(internal_user_required, name='dispatch')
class CreateNotificationView(MultipleFormView):
    """Create a notification"""
    template_name = 'alerts/create_notification.html'
    success_url = reverse_lazy('alerts:index')
    form_classes = [SupereventNotificationForm, EventNotificationForm]

    def get_context_data(self, **kwargs):
        kwargs['idx'] = 0
        if (self.request.method in ('POST', 'PUT')):
            form_keys = [f.key for f in self.form_classes]
            idx = form_keys.index(self.request.POST['key_field'])
            kwargs['idx'] = idx
        return kwargs

    def get_form_kwargs(self, *args, **kwargs):
        kw = super(CreateNotificationView, self).get_form_kwargs(
            *args, **kwargs)
        kw['user'] = self.request.user
        return kw

    def form_valid(self, form):
        form.cleaned_data.pop('key_field', None)

        # Add user (from request) and category (stored on form class) to
        # the form instance, then save
        form.instance.user = self.request.user
        form.instance.category = form.category
        form.save()

        # Add message and return
        messages.info(self.request, 'Created notification: {n}.'.format(
            n=form.instance.description))
        return super(CreateNotificationView, self).form_valid(form)

    def get(self, request, *args, **kwargs):
        # Make sure user has at least one verified contact; if not, redirect
        # and display an error message
        user_has_verified_contact = request.user.contact_set.filter(
            verified=True).exists()
        if not user_has_verified_contact:
            messages.error(request, ('Error: you have no verified contacts. '
                'Create and verify a contact before creating a notification.'))
            return HttpResponseRedirect(reverse('alerts:index'))

        return super(CreateNotificationView, self).get(request, *args,
            **kwargs)

    superevent_form_valid = event_form_valid = form_valid


@method_decorator(internal_user_required, name='dispatch')
class EditNotificationView(UpdateView):
    """Edit a notification"""
    template_name = 'alerts/edit_notification.html'
    # Have to provide form_class, but it will be dynamically selected below in
    # get_form()
    form_class = SupereventNotificationForm
    success_url = reverse_lazy('alerts:index')

    def get_form_class(self):
        if self.object.category == Notification.NOTIFICATION_CATEGORY_EVENT:
            return EventNotificationForm
        else:
            return SupereventNotificationForm

    def get_form_kwargs(self, *args, **kwargs):
        kw = super(EditNotificationView, self).get_form_kwargs(
            *args, **kwargs)
        kw['user'] = self.request.user

        # Cases that have a label query actually have labels in the database.
        # But we don't want to include those in the form because
        # a) it's confusing and b) it breaks the form
        if self.object.label_query and self.object.labels.exists():
            kw['initial']['labels'] = None
        return kw

    def get_queryset(self):
        return self.request.user.notification_set.all()


@method_decorator(internal_user_required, name='dispatch')
class DeleteNotificationView(DeleteView):
    """Delete a notification"""
    success_url = reverse_lazy('alerts:index')

    def get(self, request, *args, **kwargs):
        # Override this so that we don't require a confirmation page
        # for deletion
        return self.delete(request, *args, **kwargs)

    def delete(self, request, *args, **kwargs):
        response = super(DeleteNotificationView, self).delete(request, *args,
            **kwargs)
        messages.info(request, 'Notification "{n}" has been deleted.'.format(
            n=self.object.description))
        return response

    def get_queryset(self):
        # Queryset should only contain the user's notifications
        return self.request.user.notification_set.all()


###############################################################################
# Contact views ###############################################################
###############################################################################
@method_decorator(internal_user_required, name='dispatch')
class CreateContactView(MultipleFormView):
    """Create a contact"""
    template_name = 'alerts/create_contact.html'
    success_url = reverse_lazy('alerts:index')
    form_classes = [PhoneContactForm, EmailContactForm]

    def get_context_data(self, **kwargs):
        kwargs['idx'] = 0
        if (self.request.method in ('POST', 'PUT')):
            form_keys = [f.key for f in self.form_classes]
            idx = form_keys.index(self.request.POST['key_field'])
            kwargs['idx'] = idx
        return kwargs

    def form_valid(self, form):

        # Remove key_field, add user, and save form
        form.cleaned_data.pop('key_field', None)
        form.instance.user = self.request.user
        form.save()

        # Generate message and return
        messages.info(self.request, 'Created contact "{cname}".'.format(
            cname=form.instance.description))
        return super(CreateContactView, self).form_valid(form)

    email_form_valid = phone_form_valid = form_valid


@method_decorator(internal_user_required, name='dispatch')
class EditContactView(UpdateView):
    """
    Edit a contact. Users shouldn't be able to edit the actual email address
    or phone number since that would allow them to circumvent the verification
    process.
    """
    template_name = 'alerts/edit_contact.html'
    # Have to provide form_class, but it will be dynamically selected below in
    # get_form()
    form_class = PhoneContactForm
    success_url = reverse_lazy('alerts:index')

    def get_form_class(self):
        if self.object.phone is not None:
            return PhoneContactForm
        else:
            return EmailContactForm
        return self.form_class

    def get_form(self, form_class=None):
        form = super(EditContactView, self).get_form(form_class)
        if isinstance(form, PhoneContactForm):
            form.fields['phone'].disabled = True
        elif isinstance(form, EmailContactForm):
            form.fields['email'].disabled = True
        return form

    def get_queryset(self):
        return self.request.user.contact_set.all()


@method_decorator(internal_user_required, name='dispatch')
class DeleteContactView(DeleteView):
    """Delete a contact"""
    success_url = reverse_lazy('alerts:index')

    def get(self, request, *args, **kwargs):
        # Override this so that we don't require a confirmation page
        # for deletion
        return self.delete(request, *args, **kwargs)

    def delete(self, request, *args, **kwargs):
        # Get contact
        self.object = self.get_object()

        # Contacts can only be deleted if they aren't part of a notification -
        # this will prevent cases where a user creates a notification, deletes
        # the related contact(s), and then wonders why they aren't getting
        # any notifications.
        if self.object.notification_set.exists():
            messages.error(request, ('Contact "{cname}" cannot be deleted '
                'because it is part of a notification. Remove it from the '
                'notification or delete the notification first.').format(
                cname=self.object.description))
            return HttpResponseRedirect(reverse('alerts:index'))

        # Otherwise, delete the contact and show a corresponding message.
        self.object.delete()
        messages.info(request, 'Contact "{cname}" has been deleted.'.format(
            cname=self.object.description))
        return HttpResponseRedirect(self.get_success_url())

    def get_queryset(self):
        # Queryset should only contain the user's contacts
        return self.request.user.contact_set.all()


@method_decorator(internal_user_required, name='dispatch')
class TestContactView(DetailView):
    """Test a contact (must be verified already)"""
    # Send alerts to all contact methods
    success_url = reverse_lazy('alerts:index')

    def get_queryset(self):
        return self.request.user.contact_set.all()

    def get(self, request, *args, **kwargs):
        self.object = self.get_object()

gracedb/api/v2/events/views.py
from ...v1.events.views import *

gracedb/api/v2/main/views.py
from ...v1.main.views import *

gracedb/api/v2/superevents/views.py
from ...v1.superevents.views import *

gracedb/templates/503.html
{% extends "base.html" %}

{% block title %}503 &ndash; Service Unavailable{{ object.graceid }}{% endblock %}
{% block heading %}Not Found {{ object.graceid }}{% endblock %}

{% block content %}
    <p>GraceDB is temporarily unavailable.  Please check back later.</p>
    {{ message|safe }}
{% endblock %}

gracedb/templates/base.html
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
{% load static %}

      <!--Import Stylesheets-->
      <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.2.1/dist/css/bootstrap.min.css" integrity="sha384-GJzZqFGwb1QTTN6wy59ffF1BuGJpLSa9DkKMp0DgiMDm4iYMj70gZWKYbI706tWS" crossorigin="anonymous">
      <link type="text/css" rel="stylesheet" href="{% static "css/themecolors.css" %}" />
      <link type="text/css" rel="stylesheet" href="https://cdn.datatables.net/1.10.21/css/jquery.dataTables.min.css" /> 
      <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/ekko-lightbox/5.3.0/ekko-lightbox.css" integrity="sha512-Velp0ebMKjcd9RiCoaHhLXkR1sFoCCWXNp6w4zj1hfMifYB5441C+sKeBl/T/Ka6NjBiRfBBQRaQq65ekYz3UQ==" crossorigin="anonymous" referrerpolicy="no-referrer" />
      <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/Trumbowyg/2.21.0/ui/trumbowyg.min.css" integrity="sha512-XjpikIIW1P7jUS8ZWIznGs9KHujZQxhbnEsqMVQ5GBTTRmmJe32+ULipOxFePB8F8j9ahKmCjyJJ22VNEX60yg==" crossorigin="anonymous" referrerpolicy="no-referrer" />

      <link type="text/css" rel="stylesheet" href="{% static "css/override-new.css" %}" />
      <!--Let browser know website is optimized for mobile-->
      <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
      <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">

{% block headcontents %}

    <!-- import scripts -->
    {# remove requests for favicon #}
    <link rel="icon" href="data:,">
    <title>GraceDB | {% block title %}{% endblock %}</title>
    <!-- START TESTING -->
    <script type="text/javascript">
       function changeTime(obj, label) {
           var timetype = obj.attr("value");
           if (timetype=="") { return; }
           var times = document.getElementsByName("time-"+label);
           for (i=0; i<times.length; i++) {
               newtime =  times[i].getAttribute(timetype);
               times[i].innerHTML = newtime;
           }
       }

     </script>

     <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
     <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery.form/4.3.0/jquery.form.js"></script>
     <script src="https://cdn.datatables.net/1.10.22/js/jquery.dataTables.min.js"></script>
     <script src="https://cdnjs.cloudflare.com/ajax/libs/Trumbowyg/2.21.0/trumbowyg.min.js" integrity="sha512-l6MMck8/SpFCgbJnIEfVsWQ8MaNK/n2ppTiELW3I2BFY5pAm/WjkNHSt+2OD7+CZtygs+jr+dAgzNdjNuCU7kw==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
     <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js"></script>
     <script src="https://cdnjs.cloudflare.com/ajax/libs/ekko-lightbox/5.3.0/ekko-lightbox.js"></script>
     <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js"></script>

     <!-- Trying out the TOC stuff -->
     <link rel="stylesheet"
           href="https://cdn.rawgit.com/afeld/bootstrap-toc/v1.0.1/dist/bootstrap-toc.min.css"/>
           <!-- add after bootstrap.min.js -->
           <script src="https://cdn.rawgit.com/afeld/bootstrap-toc/v1.0.1/dist/bootstrap-toc.min.js"></script>
           <!--ending the TOC stuff -->
     <!-- lightbox script --->
     <script type="text/javascript">
        $(document).on('click', '[data-toggle="lightbox"]', function(event) {
                        event.preventDefault();
                        $(this).ekkoLightbox();
                    });
     </script>

     <script type="text/javascript">
        $(function () {
          $('[data-toggle="tooltip"]').tooltip({
           placement: 'top',
           container: 'body',
           boundary: 'viewport'
        })
        })
     </script>
     {% endblock %}
     <!-- END TESTING -->
     {% block jscript %}
     {% endblock %}




</head>

<body data-spy="scroll" data-target="#toc" id="{% block pageid %}{% endblock %}"{% block bodyattrs %}{% endblock %}>

<div class="container-fluid" style="max-width: 1200px;">


   {% block nav %}
       {% include "navbar_frag.html" %}
   {% endblock %}

   <div class="container-fluid" style="padding-top: 85px">
            </br>


          {% if info_banner_enabled %}
            <center>
            <div class="alert alert-success" role="alert" style="max-width:750px;">
               {% autoescape off%}
               {{ info_banner_message }}
               {% endautoescape%}
            </div>
            </center>
          {% endif %}
        
               {% block content %}{% endblock %}

        
    </div>
            <div class="row">
                <div class="col align-self-center">
                <center>
                <img class="banner-img" src="{% static "images/nsf_4-color_bitmap_logo.png" %}" />
                <img class="banner-img" src="{% static "images/ligo-blue.gif" %}" />
                <img class="banner-img" src="{% static "images/LSC_logo50.png" %}" />
                <img class="banner-img" src="{% static "images/Virgo_logo50.png" %}" />
                <img class="banner-img" src="{% static "images/kagra.png" %}" />
                {% if user and user.username == "chad.hanna@LIGO.ORG" %}
                 <img class="banner-img" src="{% static "images/PI_Logo-anim.gif" %}" />
                {% endif %}
                {% if user and user.username == "kipp.cannon@LIGO.ORG" %}
                 <img class="banner-img" src="{% static "images/utokyo2.gif" %}" />
                {% endif %}
                </center>
            </div>
            </div>


</div>
</body>
</html>

gracedb/templates/discovery.html
{% extends "base.html" %}

{% block title %}Log-In{% endblock %}
{% block heading %}<h5>Please choose how to log in</h5><hr> {% endblock %}
{% block pageid %}Discovery Service{% endblock %}

{% block jscript %}
<link rel="stylesheet" type="text/css" href="/shibboleth-ds/idpselect.css" />
{% endblock %}

{% block content %}
<div class="d-flex p-2 flex-column justify-content-center">
<div id="idpSelect"> 
</div> 

<div>
    <script src="/shibboleth-ds/idpselect_config.js" type="text/javascript" language="javascript"></script>
    <script src="/shibboleth-ds/idpselect.js" type="text/javascript" language="javascript"></script>
</div>

<br>

<div id="consent" style="width:389px; padding:15px">
    <p>This site uses cookies to manage sessions, but not track activity across
    other sites or services.</p>

    <p>Identifying information is obtained from the Identity Provider and your
    IP address. These data are used to record annotations to GraceDB and its
    associated data products. Log files are stored and used in security audits and problem
    resolution.</p>

    <p>By proceeding, you are consenting to the use of cookies for this session.</p>
</div>
</div>

{% endblock %}

gracedb/templates/navbar_frag.html
{% load static %}

<div class="fixed-top" style="margin-top: -75px; padding-top: 75px; box-shadow: 0 0 0.2rem rgba(0,0,0,.1), 0 0.2rem 0.4rem rgba(0,0,0,.2);">
  <nav class="navbar navbar-expand-md navbar-gracedb navbar-dark">
    <a class="navbar-brand text-white" href="/">
      <img src="{% static "images/logo.svg" %}" style="width:30px;">
      GraceDB  
      {% if config_name %}
      <span class="text-danger">({{ config_name }})</span>
      {% endif %}
    </a>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#collapsibleNavbar">
    <span class="navbar-toggler-icon"></span>
  </button>

  <div class="collapse navbar-collapse" id="collapsibleNavbar">

    <ul class="navbar-nav">
      <li class="nav-item">
      <div class="btn-group">
        <a class="btn btn-small btn-navbar shadow-none" href="{% url "superevents:public-alerts-redirect" %}" role="button">Public Alerts</a>
  <button type="button" class="btn btn-small shadow-none btn-split dropdown-toggle dropdown-toggle-split" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
    <span class="sr-only">Toggle Dropdown</span>
  </button>
  <div class="dropdown-menu">
    <a class="dropdown-item" href="{% url "superevents:public-alerts" "O4" %}">O4</a>
    <a class="dropdown-item" href="{% url "superevents:public-alerts" "ER15"%}">ER15</a>
    <a class="dropdown-item" href="{% url "superevents:public-alerts" "O3" %}">O3</a>
  </div>
</div>
      </li>

      <li class="nav-item">
         <a class="nav-link text-light font-weight-light" href="{% url "latest" %}">Latest</a>
      </li>

      <li class="nav-item">
         <a class="nav-link text-light font-weight-light" href="{% url "mainsearch" %}">Search</a>
      </li>

      {% if user_is_internal %}

        <li class="nav-item">
           <a class="nav-link text-light font-weight-light" href="{% url "alerts:index" %}">Notifications</a>
        </li>

        <li class="nav-item">
           <a class="nav-link text-light font-weight-light" href="{% url "manage-pipelines" %}">Pipelines</a>
        </li>

      {% elif user_is_lvem %}
        <li class="nav-item">
           <a class="nav-link text-light font-weight-light" href="{% url "manage-password" %}">Manage Password</a>
        </li>

      {% endif %}

      <li class="nav-item">
         <a class="nav-link text-light font-weight-light" href="{% url "home" %}documentation/" target="_blank">Documentation</a>
      </li>

      {% if user %}
          {% if user.is_superuser %}
              <li class="nav-item">
                 <a class="nav-link text-light font-weight-light" href="{% url "home" %}admin_docs/" target="_blank">Admin Docs</a>
              </li>
          {% endif %}
      {% endif %}

      {% if user.is_authenticated %}

         <li class="nav-item">
            <a class="nav-link text-light font-weight-light" href="{% url "logout" %}?next={{ request.path }}">Logout</a>
         </li>

      {% else %}
         <li class="nav-item">
            <a class="nav-link text-light font-weight-light" href="{% url "login" %}?next={{ request.path }}">Login</a>
         </li>
      {% endif %}
    </ul>
  </div>
  </nav>

  <div class="container-fluid navbar-gracedb text-left">
           <span class="text-light" style="font-size:8pt">  
           {% if user.is_authenticated %}
           Authenticated as:
           {% if user.first_name %}
               {{ user.get_full_name }}
           {% else %}
               {{ user.username }}
           {% endif %}
           {% else %}
           Please log in to view full database contents.
           </span>
         {% endif %}
  </div>
</div>